
%{!?pyver: %global pyver %(%{__python} -c "import sys ; print sys.version[:3]")}

%if 0%{?fedora} > 12
%global with_python3 1
%else
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib())")}
%endif

%global srcname cement
Name: python-%{srcname}
Version: 2.2.2
Release: 4%{?dist}
Summary: CLI Application Framework for Python
Group: Applications/System 
License: BSD 

URL: http://builtoncement.com
Source0: http://builtoncement.com/cement/2.2/source/%{srcname}-%{version}.tar.gz 

#Patch1: py33-fixes.patch
#Patch2: cement-2.0.2-tests.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

BuildRequires: python2-devel, python-setuptools, python-nose, python-coverage

# for testing only
BuildRequires: python-configobj, python-pylibmc, PyYAML, pystache
BuildRequires: python-genshi, memcached
%if 0%{?with_python3}
BuildRequires: python3-configobj, python3-PyYAML, python3-pystache
%endif



%if 0%{?with_python3}
BuildRequires: python3-devel, python3-setuptools, python3-nose, python3-coverage
%endif

%description
Cement is an advanced CLI Application Framework for Python. Its goal is to 
introduce a standard, and feature-full platform for both simple and complex 
command line applications as well as support rapid development needs without 
sacrificing quality.

%if 0%{?with_python3}
%package -n python3-cement
Summary: CLI Application Framework for Python 3
Group: Applications/System

%description -n python3-cement
Cement is an advanced CLI Application Framework for Python. Its goal is to
introduce a standard, and feature-full platform for both simple and complex
command line applications as well as support rapid development needs without
sacrificing quality.
%endif

%prep
%setup -q -n cement-%{version}
#%%patch1 -p1
#%patch2 -p1 -b .tests

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif # with_python3

%build
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
CFLAGS="$RPM_OPT_FLAGS" %{__python3} setup.py build
popd
%endif # with_python3


%install
rm -rf %{buildroot}

%{__python} setup.py install --skip-build --root %{buildroot}

%if 0%{?with_python3}
    pushd %{py3dir}
        %{__python3} setup.py install --skip-build --root %{buildroot} 
    popd
%endif

# cleanup tests from sitelib
rm -rf %{buildroot}%{python_sitelib}/tests/

%if 0%{?with_python3}
rm -rf %{buildroot}%{python3_sitelib}/tests/
%endif


%check
memcached 2>&1 >/dev/null &
%{__python} setup.py nosetests --verbosity 3 

%if 0%{?with_python3}
    pushd %{py3dir}
        %{__python3} setup.py nosetests --verbosity 3
    popd
%endif

# don't leave memcached running
/usr/bin/ps auxw \
    | grep [m]emcached \
    | awk {' print $1 '} \
    | xargs /usr/bin/kill 2>&1 >/dev/null \
    ||:

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README.md LICENSE ChangeLog doc
%{python_sitelib}/%{srcname}*

%if 0%{?with_python3}
%files -n python3-cement
%doc README.md LICENSE ChangeLog doc
%{python3_sitelib}/%{srcname}*
%endif

%changelog
* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed May 28 2014 Kalev Lember <kalevlember@gmail.com> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Changes/Python_3.4

* Thu May 15 2014 BJ Dierkes <derks@datafolklabs.com> - 2.2.2-1
- Latest sources (minor release) from upstream.  Full ChangeLog:
  http://builtoncement.com/2.2/changes.html#wed-apr-16-2014

* Wed May 14 2014 Bohuslav Kabrda <bkabrda@redhat.com> - 2.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Changes/Python_3.4

* Fri Mar 28 2014 BJ Dierkes <derks@datafolklabs.com> - 2.2.0-1
- Latest stable sources from upstream.  Full change log available at
  http://builtoncement.com/2.2/changes.html
- Removed Patch2: cement-2.0.2-tests.patch (applied upstream)
- Added additional BRs for testing

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Aug 27 2012 BJ Dierkes <wdierkes@rackspace.com> - 2.0.2-1
- Latest sources from upstream.
  http://builtoncement.com/2.0/changes.html  
- Removed Patch1: py33-fixes.patch (applied upstream)
- Added Patch2: cement-2.0.2-tests.patch

* Mon Aug 06 2012 BJ Dierkes <wdierkes@rackspace.com> - 2.0.0-1
- Latest sources from upstream.  
  http://cement.readthedocs.org/en/stable-2.0.x/changes/#fri-aug-03-2012

* Sat Aug 04 2012 David Malcolm <dmalcolm@redhat.com> - 1.9.14-5
- rebuild for https://fedoraproject.org/wiki/Features/Python_3.3

* Fri Aug  3 2012 David Malcolm <dmalcolm@redhat.com> - 1.9.14-4
- add patch for python 3.3 support (patch 1)

* Fri Aug  3 2012 David Malcolm <dmalcolm@redhat.com> - 1.9.14-3
- remove rhel logic from with_python3 conditional

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.9.14-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jul 16 2012 BJ Dierkes <wdierkes@rackspace.com> - 1.9.14-1
- Latest source from upstream.

* Tue Jul 03 2012 BJ Dierkes <wdierkes@rackspace.com> - 1.9.10-1
- Latest sources from upstream.  
- Updated spec for new source (removed devtools subpackage).
- No longer build docs, but rather just toss them in %%doc 

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jul 12 2011 BJ Dierkes <wdierkes@rackspace.com> - 0.8.18-2
- Removed Patch0: cement-testing.patch (reworked in Patch2)
- Added Patch1: cement-0.8.18-setuptools.patch
- Added Patch2: cement-0.8.18-paths.patch
- No longer include 'test_runner.py' hack (just use setup.py nosetests)

* Thu Jul 07 2011 BJ Dierkes <wdierkes@rackspace.com> - 0.8.18-1
- Latest sources from upstream.  Full changelog available at:
  http://builtoncement.org/cement/0.8/doc/changes.html
- BuildRequire: python-coverage for tests

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.16-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Feb 07 2011 BJ Dierkes <wdierkes@rackspace.com> - 0.8.16-1
- Latest sources from upstream.  Full changelog available at:
  http://builtoncement.org/cement/0.8/ChangeLog

* Tue Jan 11 2011 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-6
- Requires: python-setuptools (for pkg_resources)

* Mon Jan 03 2011 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-5
- Added comment at top of spec regarding bundled 'pkgutil'

* Thu Dec 16 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-4
- Change comment for License to reference install location rather
  than source location of pkgutil.

* Tue Dec 14 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-3
- No longer use a %%{python} macro for the python package name
- BuildRequires: python2-devel per FPG

* Tue Dec 14 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-2
- Cleaned up use of macros a bit (no longer use %%{real_name}
- Include %%{python_sitelib}/cement dir under base package
- No longer pass '--single-version-externally-managed'

* Thu Dec 09 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.14-1
- Latest sources from upstream
- Add in -devtools package (now bundled in upstream source)
- Optionally run nose tests under cement.test

* Mon Dec 06 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.12-1
- Latest sources from upstream.
- Changed licse to MIT and Python (pkgutil backport)

* Wed Dec 01 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.10-1
- Latest sources from upstream
- Removed -devtools package, will create separate package for it

* Fri Jun 11 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.6-1
- Latest source from upstream
- Remove -devel package (moved to -devtools following upstream)
- Updated Patch0: cement-0.8.6-noreqs.patch
- Adding Patch1: cement-0.8.6-doc.patch (again)

* Mon Jun 07 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8.4-1
- Latest sources from upstream
- Re-write Patch0: noreqs.patch
- Removed Patch1: cement-0.8-doc.patch (no longer applicable)
- Removed Patch2: cement-0.8-tests.patch (applied upstream)

* Fri Apr 30 2010 BJ Dierkes <wdierkes@rackspace.com> - 0.8-1
- Initial spec build
